# coding: utf-8

"""
    Polyaxon SDKs and REST API specification.

         # noqa: E501

    The version of the OpenAPI document: 2.1.3-rc0
    Contact: contact@polyaxon.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
from inspect import getfullargspec
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, StrictInt, StrictStr

class V1FailureEarlyStopping(BaseModel):
    """
    FailureEarlyStoppingSchema specification Early stopping based on failure config. this policy stops based on a percentage of failed runs at every evaluation.
    """
    kind: Optional[StrictStr] = 'failure_early_stopping'
    percent: Optional[StrictInt] = Field(None, description="The percentage of failed runs, at each evaluation interval. e.g. 1 - 99.")
    __properties = ["kind", "percent"]

    class Config:
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> V1FailureEarlyStopping:
        """Create an instance of V1FailureEarlyStopping from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> V1FailureEarlyStopping:
        """Create an instance of V1FailureEarlyStopping from a dict"""
        if obj is None:
            return None

        if type(obj) is not dict:
            return V1FailureEarlyStopping.parse_obj(obj)

        _obj = V1FailureEarlyStopping.parse_obj({
            "kind": obj.get("kind") if obj.get("kind") is not None else 'failure_early_stopping',
            "percent": obj.get("percent")
        })
        return _obj

